# EMBEDDED LINUX

### Instructions

The Markdown files (`tp/elinux_##_xxxxx.md`)  contains the instructions for the lab sessions. 

Get familiar with Markdown language as it is really widespread (for instance, it is used for README files on Github). In few words, the Markdown language allows text formatting when seen through a Markdown editor, but can also be read as a usual text file with basic editors. 

For these labs the files always start with the objectives and a list of contents. The following sections contains the instructions you have to follow. Most of the instructions are command lines that must be executed in a Linux shell.

**When you see commands lines, understand them before executing them! Some might be hazardous!**
Even better: add comments in the Markdown files so that you can keep track of what the commands do.




-------------------------------------------------------------------------------
## BEAGLE BONE BLACK PROJECT


### Informations and Resources
* Open source hardware and software project
* Educational and industrial solutions
* Industrial processor SoC TI AM33xx (vs multimedia processor on Raspberry Pi)
* Founder: Drew Frustini
* Co-founder: Jason Kridner
* Main project maintainer: Robert C. Nelson
* Web site: https://beagleboard.org/bone



### Youtube - Beagle BoF - Drew Fustini, BeagleBoard.org Foundation

https://www.youtube.com/watch?v=CWCNKquoVow
https://www.elinux.org/images/archive/9/99/20170222171704!Beagle-bof-elc17.pdf



### Main maintainer - Robert C Nelson - Wiki and Repository

https://www.digikey.com/eewiki/display/linuxonarm/BeagleBone+Black
https://www.rcn-ee.com/




-------------------------------------------------------------------------------
## WORKING DIRECTORY


Download *elinux.tar.xz* archive from ENSICAEN's Moodle platform

```sh
cd /<working_directory_path>
wget https://foad.ensicaen.fr/<moodle_path>/elinux.tar.xz
tar -xJf elinux.tar.xz
```


Practical work tree structure in *elinux/tp/disco* (discovery) directory

```shell
cd elinux/tp/disco && ls
```




-------------------------------------------------------------------------------
## ENVIRONMENT VARIABLES DEPENDENCIES

We will use many environment variables.

```bash
cd /<working_directory_path>/elinux/tp/disco
export EXAMPLE_VAR=`pwd`
echo $EXAMPLE_VAR 
```

Environment variables only exist while the bash process is alive. Once shut down, environment variables are erased. Scripts will help us creating environment variables at the beginning of each lab session.



Display the content of the `disco/scripts/start_elinux.sh` script.

```bash
cat ./scripts/start_elinux.sh
```

* What is it supposed to do?
> 
>
> 

Run the script, then display the environment variables.

```bash
./scripts/start_elinux.sh
echo $DISCOPATH
```

* Why don't you see `DISCOPATH`?
>
>
> 

Source the script, and check out for the `DISCOPATH` environment variable.

```bash
source ./scripts/start_elinux.sh
echo $DISCOPATH
```

Now it works.

You will have to update this script many times as it will help you with basic tasks once you understood them.
You shall run the script in `elinux/tp/disco` directory at the beginning of each lab session.